%% Asignment 2 is to solve an equation 
%  x^2-3=0, for x in [1,2]
%  
% Fill out the question marks to produce the appropriate results. 
% Results : should be a plot as seen in the folder

tol = 1.e-10;       % tolerance for errors
a = 1.0; b = 3.0;    % interval for the root 
nmax = 100; % number of iterations

% Initialization
itcount = 0;    
error = 1.0;

% Graph of the function
xval = linspace(a,b,100);
for i=1:100 
    fval(i) = func(xval(i));
end 
plot(xval,fval);
grid on; hold on;

% iteration begins here
while (itcount <= nmax && error >= tol)
    itcount = itcount + 1;
    % Generate and save iteratres
    x = ???????? %% determine what goes here!!
    z(itcount) = x;
    fa = func(a);
    fb = func(b);
    fx = func(x);
    error = abs(fx);
    if (error < tol)
        x_final = x;
    else
        if (??????) % determine what goes here!
            % root is between a and x
            b = x;
        else
            % root is between x and b
            a = x;
        end
    end
    plot(z(1:itcount),zeros(itcount,1),'????');
    pause(5)
end
if (itcount < nmax)
    val = func(x);
    fprintf(1,'Converged solution after %5d iterations',?????); % determine
    fprintf(1,' is %15.7e, %e \n',??????, ?????); % determine
else
    fprintf(1,'Not converged after %5d iterations',nmax);
end

% this is the function value to solve
function val = func(x)
val = x^2 -3;
end